<?php
// $Id: 30_SSL.php.create.Vsite
// Copyright (c) 2008-2022 Michael Stauber, SOLARSPEED.NET
// Copyright (c) 2008-2022 Team BlueOnyx, BLUEONYX.IT

include_once('UIExtension.php');

class SSLExtension extends UIExtension
{
    function display(&$helper, &$container, $prams)
    {
        $CI = get_instance();
        $BX_SESSION = $CI->getBX_SESSION();
        $factory = $helper->getHtmlComponentFactory('base-ssl');
        $cce = $helper->getCceClient();

        $defaults = $cce->get($prams['CCE_SERVICES_OID'], 'SSL');

        //
        //-- Reseller: Can the reseller that owns this Vsite modify this?
        //
        $VsiteOwnerObj = $BX_SESSION['loginUser'];
        $access = "rw";
        if ($VsiteOwnerObj['name'] != "admin") {
            $resellerCaps = $cce->scalar_to_array($VsiteOwnerObj['capabilities']);
            if (!in_array('resellerSSL', $resellerCaps)) {
                $defaults["enabled"] = '0';
                $access = 'r';
            }
        }

        //--

        $xxx = $factory->getBoolean('SSL_enabled', $defaults['enabled'], $access);
        $page_id = $prams['PAGED_BLOCK_DEFAULT_PAGE'];
        $container->addFormField(
            $xxx,
            $factory->getLabel('enabled'),
            $page_id);
    }

    function handle(&$helper, &$errors, $prams, &$attributes)
    {
        $this->attributes = $attributes;

        $cce = $helper->getCceClient();

        // set the enabled value
        $cce->set($prams['CCE_OID'], 'SSL', array('enabled' => $this->attributes['SSL_enabled']));

        $errors = array_merge($errors, $cce->errors());
    }
}
?>